function [Calloffs, Forecasts] = CFgensortNew(OrderArray, currentDay, endDay)

c = 1;
f = 1;


for i = 1:length(OrderArray)
    if OrderArray(i,1) >=currentDay && OrderArray(i,1) <=endDay %Order has delivery in planning horizon
        if OrderArray(i,1) - OrderArray(i,6) <= currentDay      %Order has arrived --> call-off
            Calloffs(c,1:6) = OrderArray(i,1:6);
            c = c+1;
        else                                                    %Order has not arrived --> forecast
            Forecasts(f,1:6) = OrderArray(i,1:6); 
            f = f+1;
        end
    end
end

Calloffs = sortrows(Calloffs, [2 4 1]);
Forecasts = sortrows(Forecasts, [2 4 5]); 

%Check that customer,product,time combination is unique
for i = 2:length(Calloffs)
    if Calloffs(i,1) == Calloffs(i-1,1) && Calloffs(i,2) == Calloffs(i-1,2) && Calloffs(i,4) == Calloffs(i-1,4) 
       Calloffs(i,3) = Calloffs(i,3) + Calloffs(i-1,3);
       Calloffs(i-1,:) = zeros(1, 6);
    end
end

Calloffs = Calloffs(any(Calloffs,2),:);

for i = 2:length(Forecasts)
    if Forecasts(i,2) == Forecasts(i-1,2) && Forecasts(i,4) == Forecasts(i-1,4) && Forecasts(i,5) == Forecasts(i-1,5)
       Forecasts(i,3) = Forecasts(i,3) + Forecasts(i-1,3);
       Forecasts(i-1,:) = zeros(1, 6);
    end
end

Forecasts = Forecasts(any(Forecasts,2),:);



end