function [CustomerDemand, Prognosis] = DemandPrognosisGenerate(Calloffs, Forecasts, H_Customers, noCustomers, noProducts, horizon, noWeeks, currentDay, endDay, startWeek, endWeek, CustomerDemandRedjected, CalloffRedjected) 

    %Read forecast data
    F_c = Forecasts(1:end, 2); %Customers
    F_w = Forecasts(1:end, 5); %Week
    F_p = Forecasts(1:end, 4); %Product
    F_q = Forecasts(1:end, 3); %Quantity
   
    %Write forecastdata
    n = 1;

    Prognosis = zeros(noCustomers, noProducts, noWeeks);
    %Create matrix for forecast data
    for c = 1:noCustomers
        for p = 1:noProducts
            for w = startWeek:endWeek
                if F_c(n) == H_Customers(c) && F_w(n) == w && F_p(n) == p %Find match 
                    Prognosis(c, p, w - startWeek + 1) = F_q(n);
                    if n < length(F_c)
                        n = n + 1;
                    end
                end      
            end
        end
    end
                 
    %Read call-off data
    D_c = Calloffs(1:end, 2); %Customers
    D_t = Calloffs(1:end, 1); %Delivery time(day)
    D_p = Calloffs(1:end, 4); %Product
    D_q = Calloffs(1:end, 3); %Quantity
    
    %Write call-off data
    m = 1;
    CustomerDemand = zeros(noCustomers, noProducts, horizon);

    for c = 1:noCustomers
        for p = 1:noProducts
            for t = currentDay:endDay
                if D_c(m) == H_Customers(c) && D_t(m) == t && D_p(m) == p %Find match 
                    CustomerDemand(c, p, t - currentDay + 1) = D_q(m);
                    if m < length(D_c)
                        m = m + 1;
                    end
                end      
            end
        end
    end
    
    %Remove call-off that was rejected in pervious roll
    if CalloffRedjected == 1
        for c = 1:noCustomers
            for p = 1:noProducts
                for t = 1:horizon
                    if CustomerDemand(c,p,t) > 1 && CustomerDemandRedjected(c,p,t) == 1
                        CustomerDemand(c,p,t) = 0;              %Call-off is redjected in earlier roll
                    end
                end
            end
        end
    end
    
 
    
end