%%PARAMETERS TO CHOOSE OR HARDCODE
%Parameter to hardcode
RollingModel = 1;                   
LagrangianModel = 0;                
noRolling = 35;                     
                                    
                                    
                                  
dataset = 3;                        
currentDay = 36;                     
CalloffRedjected = 1;               
LastLockPeriodProduction = 7;       %T^L, lock for seven days


horizon = 35;                       
R = 1; 


%LagrangeParametere
iterations = 300;
saveResult = 1;
resultFileLagrange = 'Run0506_300it_MH_TableRelax.mat'; % Navnet p resultatfil som blir lagret hvis man kjrer Lagrange
heuristikk = 1;
lambda0 = 2000;
LBD = 0;
UBD = 1E8;
%% GENERATING PARAMETERS 
datafileSim = strcat('rolldata',num2str(dataset),'.mat');       %Simulation set
datafilIni = strcat('inirolldata',num2str(dataset),'.mat');     %Inititial state
i = num2str(dataset);                                           %Simulation set number

datafileCost = 'dataCost1.mat';                                 %Cost data
datafileStatic = 'dataStatic.mat';                              %Remaining input data



%Load data
load(datafileSim);
load(datafileStatic);
load(datafileCost);
load(datafilIni);

%Days
endDay = currentDay + horizon - 1;
noDays = horizon;
Days = [1:noDays];

noWeeksTemp1 = ceil(horizon/7); %Assume horizon mod 7 = 0
noWeeksTemp2 = noWeeksTemp1 +1;

%Weeks
rest = mod(currentDay,7);
if rest == 1
    noWeeks = noWeeksTemp1;
else
    noWeeks = noWeeksTemp2;
end
Weeks = [1:noWeeks];
startWeek = ceil(currentDay/7);
endWeek = startWeek + noWeeks - 1;

%Sets
Customers = [1:noCustomers];
Products = [1:noProducts];

%Parameters
CustomerDemandRedjected = zeros(noCustomers, noProducts, noDays);

%% ROLLING RUN

BestMipValueTot = zeros(noRolling,1); 
BestGapValueTot = zeros(noRolling,1); 
BestBoundValueTot = zeros(noRolling,1); 
RunTimeTot = zeros(noRolling,1); 
NoIntSolTot = zeros(noRolling,1); 
ObjectiveValueListTot = cell(noRolling,1);
GapValueListTot = cell(noRolling,1);
ObjectiveDayOneTot = zeros(noRolling,1); 
ObjectiveWithProductionLockTot = zeros(noRolling,1); 
ObjectiveAdjustedTot = zeros(noRolling,1); 
ObjectiveDayOneAdjustedTot = zeros(noRolling,1); 

NrProductionLocationsTot = cell(noRolling,1);

CapacityCasthousePer = cell(noRolling,1);
CapacityCasthouseIncProgPer = cell(noRolling,1); 
CapacityCastingtablePer = cell(noRolling,1);

NrCalloffsTot = zeros(noRolling,1); 
AcceptedCalloffCountTot = zeros(noRolling,1); 
DeclinedCalloffCountTot = zeros(noRolling,1); 
AcceptedCalloffAmountTot = zeros(noRolling,1); 
DeclinedCalloffAmountTot = zeros(noRolling,1); 
AmountCalloffTot = zeros(noRolling,1); 
AmountPrognosisTot = zeros(noRolling,1); 
DeclinedQuantity = cell(noRolling, 1);
DeclinedDelivery = cell(noRolling,1);

PrognosisAcceptedTot = zeros(noRolling,1); 
DiscardPrognosisTot = zeros(noRolling,1); 
StorageTot = cell(noRolling,1);
ProductionLockTot = zeros(noRolling,1);

if LagrangianModel == 0 && RollingModel == 1
    for r = 1:noRolling 
        
      
        %Generate CustomerDemand and Prognosis parameter for this roll
        [Calloffs, Forecasts] = CFgensortNew(OrderArray, currentDay, endDay);
        [CustomerDemand, Prognosis] = DemandPrognosisGenerate(Calloffs, Forecasts, H_Customers, noCustomers, noProducts, horizon, noWeeks, currentDay, endDay, startWeek, endWeek, CustomerDemandRedjected, CalloffRedjected);
        
        %Other calculation param
        ProductionCastingtables = zeros(noCastingtables, noDays);
        ProductionCasthouses = zeros(noCasthouses, noDays);
        
        %Run Xpress
        retcode = moselexec('RollingModelHydroCompStudy.mos');
        if ~(retcode == 0)
            return;
        end
        
        %Save gap, objective
        BestMipValueTot(r) = BestMipValue;
        BestGapValueTot(r) = BestGapValue;
        BestBoundValueTot(r) = BestBoundValue;
        RunTimeTot(r) = RunTime;
        NoIntSolTot(r) = NumberIntSol;
        ObjectiveValueListTot{r} = ObjectiveValues; %All objectives found
        GapValueListTot{r} = GapValues; %All gaps found
        
        ObjectiveDayOneTot(r) = ObjectiveDayOne;
        ObjectiveDayOneAdjustedTot(r) = ObjectiveDayOneAdjusted;
        ObjectiveWithProductionLockTot(r) = ObjectiveWithProductionLock;
        ObjectiveAdjustedTot(r) = ObjectiveAdjusted;
        
        NrProductionLocationsTot{r} = NrProductionLocationsValues;
        
        %Lagrer kapasitet for frste dag i cell
        CapacityCasthousePer{r} = ProductionCasthouses(:,1); %First day cap
        CapacityCasthouseIncProgPer{r} = ProductionCasthousesIncPrognosis(:,1);%First day cap
        CapacityCastingtablePer{r} = ProductionCastingtables(:,1);%First day cap
        
        %Lagre antall call-offs
        NrCalloffsTot(r) = NrCalloffs;
        AcceptedCalloffCountTot(r) = AcceptedCalloffCount;
        DeclinedCalloffCountTot(r) = DeclinedCalloffCount;
        AcceptedCalloffAmountTot(r) = AcceptedCalloffAmount;
        DeclinedCalloffAmountTot(r) = DeclinedCalloffAmount;
        AmountCalloffTot(r) = AmountCalloff;
        AmountPrognosisTot(r) = AmountPrognosis;
        
        
        PrognosisAcceptedTot(r) = PrognosisAccepted;
        DiscardPrognosisTot(r) = DiscardPrognosis;
        DeclinedQuantity{r} = DeclinedQuantityValues;
        DeclinedDelivery{r} = DeliveryForDelincedCalloffValues;
        
        StorageTot{r} = Storage;
        ProductionLockTot(r) = ProductionLockData;
        
        %SET PARAMETERS FOR NEXT ROLL
        
        ProductionLock = ProductionLockTemp;
        DeltaAccepted = DeltaAcceptedTemp;
        InitialStorage = InitialStorageTemp;
        
        %Increment parameters for next period
        currentDay = currentDay + 1;
        endDay = currentDay + horizon - 1;
        
        %If rest = 1, rolling period starts with monday
        rest = mod(currentDay, 7);
        if rest == 1
            noWeeks = noWeeksTemp1;
            Weekday= 1;
        else
            noWeeks = noWeeksTemp2;
            Weekday = Weekday + 1;
        end
        
        Weeks = [1:noWeeks];
        startWeek = ceil(currentDay/7);
        endWeek = startWeek + noWeeks - 1;
        
        %Increment roll
        R = R+1;
    end
end
%% Running of Lagrangian Model
if LagrangianModel==1 && RollingModel == 0
    tic
    %Generate CustomerDemand and Prognosis parameter for this roll
    [Calloffs, Forecasts] = CFgensortNew(OrderArray, currentDay, endDay);
    [CustomerDemand, Prognosis] = DemandPrognosisGenerate(Calloffs, Forecasts, H_Customers, noCustomers, noProducts, horizon, noWeeks, currentDay, endDay, startWeek, endWeek, CustomerDemandRedjected, CalloffRedjected);
        
    Pi1 = 0.7*DeclineCost*CustomerDemand;    
    lambda = lambda0;
    lamRed = 0.5;
    lambdaList = zeros(iterations,1);
    StepLength1 = 0;
    LS = zeros(iterations,1);
    UBDlist = zeros(iterations,1);
    LBDlist = zeros(iterations,1);
    sameSol = 1;
    
    %Preallocation for output to be calculated
    ordersAccepted = zeros(iterations,1);
    maxOrderAccepted = zeros(iterations,1);
    avgOrderAccepted= zeros(iterations,1);
    uniqueOrdersAccepted = zeros(iterations,1);
    storageLevel = zeros(iterations,1);
    GapList = zeros(iterations,1);
    LSTime = zeros(iterations,1);
    stepLengthList = zeros(iterations,1);
    LengthSGList = zeros(iterations,1);
    BestBoundPostHeurList = zeros(iterations,1);
    BestMIPPostHeurList = zeros(iterations,1);
    BestGapPostHeurList = zeros(iterations,1);
    IterationTime = zeros(iterations,1);
    HeuristicTimeList = zeros(iterations,1);
    ResolveTimeList = zeros(iterations,1);
    %Variables to save best solution
    xbest = zeros(noCastingtables, noProducts, noDays);
    ybest = zeros(noCastingtables, noProducts, noDays);
    sbest = zeros(noCastingtables, noProducts, noDays);
    zbest = zeros(noProducts, noDays);
    abest = zeros(noCustomers, noCastingtables, noProducts, noDays);
        
    Subgradient1 = zeros(noCustomers, noProducts, noDays);
    
    for iter=1:iterations
        newSol = 0;
        newSolHeur = 0;
        lambdaList(iter) = lambda;
        LengthSG1 = 0;
        tempTime1 = toc;    
        moselexec LagrangeModelHydroKapRelaxTable.mos %Sender tilbake objvalLS, xMosel, yMosel, sMosel, zMosel, aMosel, newSol, SG1Mosel, SG2Mosel, LengthSG1, LengthSG2    
        if iter ==1
            LSTime(iter) = toc;
        else
            tempTime2 = toc;
            LSTime(iter) = tempTime2 - tempTime1;
        end
        LBD = max(LBD, objvalLS);
        LBDlist(iter) = LBD;
        LS(iter) = objvalLS;
        Subgradient1 = SG1Mosel;
        ordersAccepted(iter) = sum(aMosel(:));
        orderOnTables = sum(aMosel,2);
        maxOrderAccepted(iter) = max(orderOnTables(:));
        avgOrderAccepted(iter) = sum(orderOnTables(:))/nnz(orderOnTables(:));
        uniqueOrdersAccepted(iter) = nnz(orderOnTables(:));
        storageLevel(iter) = sum(sMosel(:)); 
        if (max(Subgradient1(:)) <= 0)
            %Sett UBD til  vre minimum av lsningen man har funnet satt inn i mlfunksjonen til det opprinnelige problemet og hittil beste UBD.
            UBD = min(UBD, newSol);
            
            %sparer p denne lsningen
            xbest = xMosel;
            ybest = yMosel;
            sbest = sMosel;
            abest = aMosel;
            zbest = zMosel;
            
        elseif heuristikk ==1 
            preheurTime = toc;
            if  iter==1 || mod(iter,20)==0 %iter > 1 && mod(iter,20) == 0
                DeltaOut = DeltaCleanHeuristic(Days, Customers, Castingtables, Products, aMosel, CostUnitTransportation);
                postheurTime = toc;
                HeuristicTime = postheurTime - preheurTime;
                HeuristicTimeList(iter) = HeuristicTime;
                preresolveTime = toc;
                moselexec OrdinaryHeuristic.mos
                postresolveTime = toc;
                ResolveTime = postresolveTime - preresolveTime;
                ResolveTimeList(iter) = ResolveTime;
                BestBoundPostHeurList(iter) = BestBoundPostHeur;
                BestMIPPostHeurList(iter) = ObjValPostHeur;
                BestGapPostHeurList(iter) = BestGapPostHeur;
                if ObjValPostHeur < UBD
                    UBD = ObjValPostHeur;
                    xbest = ProductionVariablesX;
                    ybest = ProductionVariablesY;
                    sbest = StorageVariables;
                    abest = DeltaVariables;
                    zbest = DiscardVariables;
                end
            end
        end
        
        
        %Sparer p UBDen for  se hvordan den utvikler seg
        UBDlist(iter) = UBD;
            
        %Vi beregner steglengden
        if LengthSG1 == 0
            LengthSG1 = 1;
        end
        StepLength1 = lambda * ((UBD - objvalLS) / LengthSG1);
        stepLengthList(iter) = StepLength1;
        LengthSGList(iter) = LengthSG1;
        GapList(iter) = (UBD-LBD)/UBD;
        IterationTime(iter) = toc;
        %Oppdaterer multiplikatorene
        for c=1:noCustomers
            for p=1:noProducts    
                for t=1:noDays
                    Pi1(c,p,t)= max(Pi1(c,p,t) + StepLength1*Subgradient1(c,p,t),0);
                end
            end
        end
            
        %Oppdaterer lambda om lsningen ikke har endret seg
        if iter > 1
            if UBDlist(iter) ~= UBDlist(iter-1)
                lambda = max(lambda0*0.5,2);
            end
            if LBDlist(iter) == LBDlist(iter-1)
                sameSol = sameSol+1;
            else
                sameSol = 1;
            end
            if mod(sameSol, 10) == 0
                lambda = lambda * lamRed;
                sameSol = 1;
            end
        end       
    end
    fullTime = toc;
    if saveResult == 1
        save(resultFileLagrange);
    end
end


